<?php
use WHMCS\User\Client;
use Illuminate\Database\Capsule\Manager as Capsule;

function unblockip_show($vars) {

    $returned_values = array();
	$whmcs_client_id = (int)$_SESSION['uid'];
	$query = "SELECT s.name
				FROM tblservers s, tblhosting h
				WHERE s.id = h.server AND h.userid = $whmcs_client_id AND (s.type = 'cpanel' or s.type= 'directadmin' or s.type='cpanelextended') AND h.domainstatus = 'Active'";
	$data = full_query($query);
	
	if (!mysql_num_rows($data)) {
      $isactive = 0;		
	}
	else {
      $isactive = 1;
      if (isset($_SESSION['unblockip_results'])) {
        $unblock_results = $_SESSION['unblockip_results'];
        $returned_values["unblockip"] = $unblock_results['unblocked_ip'];
        $returned_values["unblockip_alerts"] = $unblock_results['alerts'];
        $returned_values["unblockip_errors"] = $unblock_results['errors'];
        unset($_SESSION['unblockip_results']);
      }
	}
	
	$returned_values["unblockip_isactive"] = $isactive;
    return $returned_values;
}

function trigger_unblock_search($vars) {
  require_once("functions.php");
  $_SESSION['run_unblock_search'] = true;
}

function search_for_ip_block($vars) {
    

    if ($_SESSION['run_unblock_search']) {
      $_SESSION['run_unblock_search'] = false;
      require_once("functions.php");
	  
	  if ( file_exists("modules/addons/unblockip/lang/". strtolower($vars['language']).".php" )) {
        require_once("modules/addons/unblockip/lang/". strtolower($vars['language']).".php");
      }
      else {
        require_once("modules/addons/unblockip/lang/english.php");	      
      }
      
      
      $vars["_lang"] = $_ADDONLANG;
      
	  $whmcs_client_id = (int)$_SESSION['uid'];
	  $query = "SELECT s.name
	  			FROM tblservers s, tblhosting h
	  			WHERE s.id = h.server AND h.userid = $whmcs_client_id AND (s.type = 'cpanel' or s.type= 'directadmin' or s.type='cpanelextended')AND h.domainstatus = 'Active'";
	  $data = mysql_query($query);
	  
	  if (mysql_num_rows($data) != 0) {
         $table = "tbladdonmodules";
	     $fields = "setting,value";
	     $where = array("module"=>"unblockip");
	     $result = select_query($table,$fields,$where);
	     $options = array();
	     while ($data = mysql_fetch_array($result)) {
	       $option_name = $data['setting'];
	       $options["$option_name"] = $data['value'];
	     }  
         $max_unblocks = (int)$options['option1'];
         $unblock_interval = (int)$options['option2'];
         $run_automatic_ip_check = $options['option3'];
         $run_automatic_ip_check_dont_unblock = $options['option5'];
	  
         if ($run_automatic_ip_check == "on") {
	         // if max unblock option is not set or invalid, set to 5.  
	         if ($max_unblocks == 0) {
	           $max_unblocks = 5;
	         }
	  
	         if ($unblock_interval == 0) { 
	           $unblock_interval = 5;
	         }
	         $unblock_results = process_request($_SERVER['REMOTE_ADDR'], $whmcs_client_id, $max_unblocks, $unblock_interval, true);
	         if ($unblock_results['unblocked_ip'] == true) {
	           $_SESSION['unblockip_results'] = $unblock_results;
	         }  
         }
         
         if ($run_automatic_ip_check_dont_unblock == "on") {
	         // if max unblock option is not set or invalid, set to 5.  
	         if ($max_unblocks == 0) {
	           $max_unblocks = 5;
	         }
	  
	         if ($unblock_interval == 0) { 
	           $unblock_interval = 5;
	         }
	         
	         $unblock_results = process_request($_SERVER['REMOTE_ADDR'], $whmcs_client_id, $max_unblocks, $unblock_interval, true, $vars, false);

	         if ($unblock_results['alerts'] != "") {
	           $_SESSION['unblockip_results'] = $unblock_results;
	         }  
         }
	  }
  }
  
   
}

 
add_hook("ClientAreaPage",1,"search_for_ip_block");
add_hook("ClientAreaPage", 2,"unblockip_show");
add_hook("ClientLogin",1,"trigger_unblock_search");

add_hook('ClientAreaNavbars', 1, function ()
{
	 $user_id =$_SESSION['uid'];
	 $current_user = Client::find($user_id);

	 if (isset($_SESSION['uid']) && !isset($_SESSION['unblockip_isactive'])) {
       $pdo = Capsule::connection()->getPdo();
       $statement = $pdo->prepare('SELECT s.name FROM tblservers s, tblhosting h WHERE s.id = h.server AND h.userid = :uid AND (s.type = \'cpanel\' or s.type= \'directadmin\' or s.type=\'cpanelextended\') AND h.domainstatus = \'Active\'');
       $statement->bindParam(':uid', $user_id, PDO::PARAM_INT);
       $statement->execute();
       $num_services = $statement->rowCount();
       
       if ($num_services > 0) {
	     $_SESSION["unblockip_isactive"] = true;
       }
       else {
	     $_SESSION["unblockip_isactive"] = false;
       }
    }
    
	if (isset($_SESSION['uid']) && $_SESSION["unblockip_isactive"]) {
	  $current_user = Client::find($user_id);
	  
	  $lang = $current_user->language;
	  if ($lang == "") {
	     $lang = "english";
	  }
	  $_ADDONLANG = array();

	  if ( file_exists("modules/addons/unblockip/lang/". strtolower($lang.".php"))  ) {
        require("modules/addons/unblockip/lang/". strtolower($lang.".php"));
      }
      else {
        require("modules/addons/unblockip/lang/english.php");	      
      }
      
      $primaryNavbar = Menu::primaryNavbar();
      $secondaryNavbar = Menu::secondaryNavbar();
      $support_link = $primaryNavbar->getChild('Support');
      
      $support_link->addChild('unblock-ip', array(
        'label' => $_ADDONLANG["menu_label"],
        'uri' => 'index.php?m=unblockip',
        'order' => 1,
      )); 	
	}
});

?>
